// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@infoscreen.com, or by
// paper mail at:
//
// Tim Freeman
// 655 S. FairOaks Ave., Apt B-316
// Sunnyvale, CA 94086
//

#ifndef __AnyMouseTrackball_h__
#define __AnyMouseTrackball_h__

#ifndef __TypedFactory_h__
#include "TypedFactory.h"
#endif

#ifndef __AnyMouseTrackballConfiguration_h__
#include "AnyMouseTrackballConfiguration.h"
#endif

#ifndef __Action_h__
#include "Action.h"
#endif

#ifndef __SP_h__
#include "SP.h"
#endif

class String;
class Configuration;
class RecursiveSlotValue;
class AnyMouseTrackball
  : public TypedFactory <AnyMouseTrackballConfiguration, Action>
{
public:
  AnyMouseTrackball ();
  SP<AnyMouseTrackballConfiguration> typedDefaultConfiguration () const;
  String getPrettyName (const Configuration *c) const;
  SP<Action> makeIt (AnyMouseTrackballConfiguration *cbac) const;
  static SP<RecursiveSlotValue> mkMouseTrackball (RecursiveSlotValue *slot);
  static SP<RecursiveSlotValue> mkMouseTrackball (const String &name);
};

#endif
