// Fungimol - an extensible system for designing atomic-scale objects.
// Copyright (C) 2000 Tim Freeman
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
// 
// You should have received a copy of the GNU Library General Public
// License along with this library in the file COPYING.txt; if not,
// write to the Free Software Foundation, Inc., 59 Temple Place -
// Suite 330, Boston, MA 02111-1307, USA
//
// The author can be reached by email at tim@infoscreen.com, or by
// paper mail at:
//
// Tim Freeman
// 655 S. FairOaks Ave., Apt B-316
// Sunnyvale, CA 94086
//

#ifndef __BouncingBallConfiguration_h__
#define __BouncingBallConfiguration_h__

#ifndef __Float_h__
#include "Float.h"
#endif

#ifndef __BallConfiguration_h__
#include "BallConfiguration.h"
#endif

#ifndef __SP_h__
#include "SP.h"
#endif

class Configuration;

class BouncingBallConfiguration: public BallConfiguration {
  Float m_gravity;
  Float m_mass;
  Float m_stiffness;
 public:
  BouncingBallConfiguration ();
  void setGravity (Float gravity);
  Float getGravity () const;
  void setMass (Float mass);
  Float getMass () const;
  void setStiffness (Float stiffness);
  Float getStiffness () const;
  bool getRandomVelocities () const;
  void setRandomVelocities (bool b);
  SP<Configuration> copy () const;
  bool hasTheSameTypeAs (const Configuration *c) const;
};

#endif
